<template>
  <div class="new-view">
    <div class="new-view__content">
      <div class="new-view__content__form">
        <h1>New Video</h1>

        <span v-if="error" class="new-view__content__form__error">
          {{ error }}
        </span>
        <cdx-progress-bar :inline="true" v-if="loading" />

        <form @submit.prevent="handleSubmit">
          <cdx-field>
            <cdx-lookup
              :start-icon="cdxIconSearch"
              v-model:selected="article"
              @input="fetchResults"
              :menuItems="menuItems"
              :menu-config="menuConfig"
              :disabled="loading"
            />
            <br />
            <textarea
              v-model="hook"
              placeholder="[enter an interesting hook here]"
              :disabled="loading"
            ></textarea>
            <br />
            <button type="submit" :disabled="loading">Submit</button>
          </cdx-field>
        </form>
      </div>
    </div>
  </div>
</template>
<script lang="ts" setup>
import { ref } from 'vue';
import { CdxLookup, CdxField, CdxProgressBar } from '@wikimedia/codex';
import { cdxIconSearch } from '@wikimedia/codex-icons';

const article = ref<string | null>(null);
const hook = ref('');
const menuItems = ref([]);
const loading = ref(false);
const error = ref<string | null>(null);

const menuConfig = {
  boldLabel: true,
};

const handleSubmit = () => {
  const wikiUrl = article.value;

  if (!wikiUrl) {
    return;
  }
  loading.value = true;
  error.value = null;
  const articleTitle = wikiUrl.split('/').pop();

  const URL = `/dyk-custom?articleTitle=${articleTitle}&hook=${hook.value}`;
  fetch(URL)
    .then((response) => {
      if (response.ok) {
        return response.json();
      } else {
        response.text().then((text) => {
          error.value =
            'Failed to submit: ' + response.statusText + ' - ' + text;
          loading.value = false;
        });
      }
    })
    .then((data) => {
      console.log(data);
      const REDIRECT_URL = `/facts/${data.factId}`;
      window.location.href = REDIRECT_URL;
    })
    .catch((error) => {
      console.error(error);
      error.value = 'Failed to submit';
      loading.value = false;
    });
};

function fetchResults(query: string) {
  const url = `https://en.wikipedia.org/w/api.php?action=opensearch&format=json&search=${query}&origin=*`;
  fetch(url)
    .then((response) => response.json())
    .then((data) => {
      menuItems.value = data[1].map((title: string, index: number) => {
        return {
          value: data[3][index],
          label: title,
        };
      });
    });
}
</script>

<style>
.new-view {
  display: flex;
  flex-direction: column;
  height: 100%;
}

.new-view__content {
  display: grid;
  grid-template-columns: var(--grid);
}

.new-view__content__form {
  grid-column: content;
  text-align: center;

  textarea {
    width: 100%;
    height: 100px;
    margin: 10px 0;
  }

  button {
    margin: 10px 0;
    width: 100%;
  }
}
</style>
